;; ErgonomyDreams/theme.jl
;; $Id$

;;  *** Ergonomy Dreams ***
;;        for Sawfish
;;
;; -> Try with "Ergonomy" theme for GTK.
;;    (I'll try to get Ergonomy Dreams theme for GTK as soon as possible :).
;;
;; This theme is based on: 
;;   "BlueSteel" for Sawfish (by John Harper); and
;;   "Ergonomy" for Enlightenment (by me :);
;;
;; By:
;;   Adrin Ferrer <aferrer@dit.upm.es>

;; This is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


(let*
    (
     ;## 734x449.
     (x-imag 734)
     (y-imag 449)

     (x-wind
       (lambda (w)
	 (let
	   ()
	   (car (window-dimensions w))
	 )
       )
     )

     (y-wind
       (lambda (w)
	 (let
	   ()
	   (cdr (window-dimensions w))
	 )
       )
     )

     (x-proportion
       (lambda (w)
	 (let
	   ()
	   (/ (* 1000 (car (window-dimensions w))) x-imag)
	 )
       )
     )

     (y-proportion
       (lambda (w)
	 (let
	   ()
	   (/ (* 1000 (cdr (window-dimensions w))) y-imag)
	 )
       )
     )


;*******************
     (menu-i (list (make-image "gnome.png")
		   (make-image "gnome.png") (make-image "gnome-active.png")
		   (make-image "gnome-selected.png")))
       
     (title-i (list (make-image "title-bg.png")
		    (make-image "title.png")))
       

     (wind-topleft (list (make-image "wind-topleft.png")))
       
     (wind-topright (list (make-image "wind-topright.png")))
       
     (wind-rightbottom (list (make-image "wind-rightbottom.png")))
       
     (wind-bottomleft (list (make-image "wind-bottomleft.png")))
       
     (wind-top (list (make-image "wind-top.png")))
       
     (wind-right (list (make-image "wind-right.png")))
       
     (wind-bottom (list (make-image "wind-bottom.png")))
       
     (wind-left (list (make-image "wind-left.png")))
       
       
     ;; 12x16
     (max-i (list (make-image "max-bg.png")
		  (make-image "max.png") (make-image "max-active.png")
		  (make-image "max-selected.png")))
       
     ;; 12x16
     (min-i (list (make-image "min-bg.png")
		  (make-image "min.png") (make-image "min-active.png")
		  (make-image "min-selected.png")))
       
     ;; 14x16
     (close-i (list (make-image "close-bg.png")
		    (make-image "close.png") (make-image "close-active.png")
		    (make-image "close-selected.png")))
       
       
;***************
     (frame `(
	      ;## 36x24
	      ((background . ,wind-topleft)
	       (left-edge . ,(lambda (w) (/ (* (x-proportion w) -36) 1000)))
	       (top-edge . ,(lambda (w) (/ (* (y-proportion w) -24) 1000)))
	       (right-edge . ,(lambda (w) (x-wind w) ))
	       (bottom-edge . ,(lambda (w) (y-wind w) ))
	       (class . top-left-corner))

	      ;## 38x25
	      ((background . ,wind-topright)
	       (right-edge . ,(lambda (w) (/ (* (x-proportion w) -38) 1000)))
	       (top-edge . ,(lambda (w) (/ (* (y-proportion w) -25) 1000)))
	       (left-edge . ,(lambda (w) (x-wind w) ))
	       (bottom-edge . ,(lambda (w) (y-wind w) ))
	       (class . top-right-corner))

	      ;## 36x23
	      ((background . ,wind-rightbottom)
	       (right-edge . ,(lambda (w) (/ (* (x-proportion w) -36) 1000)))
	       (bottom-edge . ,(lambda (w) (/ (* (y-proportion w) -23) 1000)))
	       (left-edge . ,(lambda (w) (x-wind w) ))
	       (top-edge . ,(lambda (w) (y-wind w) ))
	       (class . bottom-right-corner))

	      ;## 34x23
	      ((background . ,wind-bottomleft)
	       (left-edge . ,(lambda (w) (/ (* (x-proportion w) -34) 1000)))
	       (bottom-edge . ,(lambda (w) (/ (* (y-proportion w) -23) 1000)))
	       (right-edge . ,(lambda (w) (x-wind w) ))
	       (top-edge . ,(lambda (w) (y-wind w) ))
	       (class . top-right-corner))

	      ;## 734x75
	      ((background . ,wind-top)
	       (top-edge . ,(lambda (w) (/ (* (y-proportion w) -75) 1000)))
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . ,(lambda (w) (y-wind w) ))
	       (class . top-border))

	      ;## 122x449
	      ((background . ,wind-right)
	       (right-edge . ,(lambda (w) (/ (* (x-proportion w) -122) 1000)))
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (left-edge . ,(lambda (w) (x-wind w) ))
	       (class . right-border))

	      ;## 734x74
	      ((background . ,wind-bottom)
	       (bottom-edge . ,(lambda (w) (/ (* (y-proportion w) -74) 1000)))
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . ,(lambda (w) (y-wind w) ))
	       (class . bottom-border))

	      ;## 122x449
	      ((background . ,wind-left)
	       (left-edge . ,(lambda (w) (/ (* (x-proportion w) -122) 1000)))
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (right-edge . ,(lambda (w) (x-wind w) ))
	       (class . left-border))


	      ((background . ,title-i)
	       (left-edge . -10)
	       (top-edge . -30)
	       (right-edge . -10)
	       (foreground . "black")
	       (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
	       (text . ,window-name)
	       (y-justify . 6)
	       (x-justify . 27)
	       (cursor . left_ptr)
	       (class . title))

	      ((background . ,menu-i)
	       (left-edge . -2)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . menu-button))

	      ((background . ,min-i)
	       (right-edge . 34)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . iconify-button))

	      ((background . ,max-i)
	       (right-edge . 16)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . maximize-button))

	      ((background . ,close-i)
	       (right-edge . -2)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . close-button))
     ))


;*************
     (shaped-frame `(
	      ((background . ,title-i)
	       (left-edge . -10)
	       (top-edge . -30)
	       (right-edge . -10)
	       (foreground . "black")
	       (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
	       (text . ,window-name)
	       (y-justify . 6)
	       (x-justify . 27)
	       (cursor . left_ptr)
	       (class . title))

	      ((background . ,menu-i)
	       (left-edge . -2)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . menu-button))

	      ((background . ,min-i)
	       (right-edge . 34)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . iconify-button))

	      ((background . ,max-i)
	       (right-edge . 16)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . maximize-button))

	      ((background . ,close-i)
	       (right-edge . -2)
	       (top-edge . -25)
	       (cursor . left_ptr)
	       (class . close-button))
	))

  )

;*************
;*************
  (add-frame-style 'ErgonomyDreams
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    frame)
			   ((eq type 'shaped-transient)
			    frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)))))
